// ChannelDecimateView.h : interface of the CChannelDecimateView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHANNELDECIMATEVIEW_H__1D85ED90_1768_11D5_BAB6_000000000000__INCLUDED_)
#define AFX_CHANNELDECIMATEVIEW_H__1D85ED90_1768_11D5_BAB6_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// The enum implies what colour space to convert to,
// and what channels to filter.
enum EFilteredColours
{
	k_filterY,
	k_filterU,
	k_filterV,
	k_filterUV,
	k_filterI,
	k_filterQ,
	k_filterIQ,
	k_filterR,
	k_filterG,
	k_filterB,
	// I could have put in options for filtering all three channels -
	// either RGB, YUV or YIQ. However, there's no point. All three
	// would look identical - it's just normal down sampling.
	k_filterNone
};

class CChannelDecimateView : public CScrollView
{
	typedef CScrollView base;
protected: // create from serialization only
	CChannelDecimateView();
	DECLARE_DYNCREATE(CChannelDecimateView)

private:
#ifdef	GDCDEMO
	bool		m_maximized;
#endif
	int			m_magnification;
	int			m_decimationAmount;
	EFilteredColours	m_filteredColours;
	CSBitmap	m_filteredBitmap;
	void		FilterBitmap();
	void		ForceRecalc();

// Attributes
public:
	CChannelDecimateDoc* GetDocument();
	void SetMagnification(int mag);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChannelDecimateView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChannelDecimateView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CChannelDecimateView)
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnView1xmagnification();
	afx_msg void OnUpdateView1xmagnification(CCmdUI* pCmdUI);
	afx_msg void OnView2xmagnification();
	afx_msg void OnUpdateView2xmagnification(CCmdUI* pCmdUI);
	afx_msg void OnChannelsDecimateIncrease();
	afx_msg void OnChannelsDecimateDecrease();
	afx_msg void OnView3xmagnification();
	afx_msg void OnUpdateView3xmagnification(CCmdUI* pCmdUI);
	afx_msg void OnView4xmagnification();
	afx_msg void OnUpdateView4xmagnification(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnChannelsDecimatex(int ID);
	afx_msg void OnUpdateChannelsDecimatex(CCmdUI* pCmdUI);
	afx_msg void OnChannelsY(int ID);
	afx_msg void OnUpdateChannelsY(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ChannelDecimateView.cpp
inline CChannelDecimateDoc* CChannelDecimateView::GetDocument()
   { return (CChannelDecimateDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHANNELDECIMATEVIEW_H__1D85ED90_1768_11D5_BAB6_000000000000__INCLUDED_)
