// CompositeViewerDoc.cpp : implementation of the CCompositeViewerDoc class
//

/*
Copyright 2001 Bruce Dawson, Cygnus Software
For more information, visit http://www.cygnus-software.com/papers/
or e-mail: comments@cygnus-software.com

This code may be redistributed as long as this notice is kept intact.
*/

#include "stdafx.h"
#include "CompositeViewer.h"

#include "CompositeViewerDoc.h"
#include "setcolour.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompositeViewerDoc

IMPLEMENT_DYNCREATE(CCompositeViewerDoc, CDocument)

BEGIN_MESSAGE_MAP(CCompositeViewerDoc, CDocument)
	//{{AFX_MSG_MAP(CCompositeViewerDoc)
	ON_COMMAND(ID_VIEW_SETCOLOURS, OnSetcolours)
	ON_COMMAND(ID_VIEW_SHOWDETAILS, OnViewShowdetails)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SHOWDETAILS, OnUpdateViewShowdetails)
	ON_COMMAND(ID_VIEW_CLIP, OnViewClip)
	ON_UPDATE_COMMAND_UI(ID_VIEW_CLIP, OnUpdateViewClip)
	ON_COMMAND(ID_COLOURS_RED, OnColoursRed)
	ON_COMMAND(ID_COLOURS_GREEN, OnColoursGreen)
	ON_COMMAND(ID_COLOURS_BLUE, OnColoursBlue)
	ON_COMMAND(ID_COLOURS_CYAN, OnColoursCyan)
	ON_COMMAND(ID_COLOURS_MAGENTA, OnColoursMagenta)
	ON_COMMAND(ID_COLOURS_YELLOW, OnColoursYellow)
	ON_COMMAND(ID_COLOURS_WHITE, OnColoursWhite)
	ON_COMMAND(ID_COLOURS_BLACK, OnColoursBlack)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompositeViewerDoc construction/destruction

CCompositeViewerDoc::CCompositeViewerDoc()
	: m_RGB(1, 1, 0),
	m_details(true),
	m_clip(true)
{
}

CCompositeViewerDoc::~CCompositeViewerDoc()
{
}

BOOL CCompositeViewerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCompositeViewerDoc serialization

void CCompositeViewerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCompositeViewerDoc diagnostics

#ifdef _DEBUG
void CCompositeViewerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCompositeViewerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCompositeViewerDoc commands

void CCompositeViewerDoc::OnSetcolours() 
{
	POSITION pos = GetFirstViewPosition();
	CView* pFirstView = GetNextView( pos );

	SetColour	dialog(&m_RGB, pFirstView);
	dialog.DoModal();
}

void CCompositeViewerDoc::OnViewShowdetails() 
{
	m_details = !m_details;
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnUpdateViewShowdetails(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_details);
}

void CCompositeViewerDoc::OnViewClip() 
{
	m_clip = !m_clip;
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnUpdateViewClip(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_clip);
}

void CCompositeViewerDoc::OnColoursRed() 
{
	m_RGB = DoubleRGB(1, 0, 0);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursGreen() 
{
	m_RGB = DoubleRGB(0, 1, 0);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursBlue() 
{
	m_RGB = DoubleRGB(0, 0, 1);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursCyan() 
{
	m_RGB = DoubleRGB(0, 1, 1);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursMagenta() 
{
	m_RGB = DoubleRGB(1, 0, 1);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursYellow() 
{
	m_RGB = DoubleRGB(1, 1, 0);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursWhite() 
{
	m_RGB = DoubleRGB(1, 1, 1);
	UpdateAllViews(0);
}

void CCompositeViewerDoc::OnColoursBlack() 
{
	m_RGB = DoubleRGB(0, 0, 0);
	UpdateAllViews(0);
}
