// CompositeViewerDoc.h : interface of the CCompositeViewerDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPOSITEVIEWERDOC_H__06ADA4EE_F991_11D4_BA86_000000000000__INCLUDED_)
#define AFX_COMPOSITEVIEWERDOC_H__06ADA4EE_F991_11D4_BA86_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "imagelibrary/colourspace.h"
typedef TypeRGB<double> DoubleRGB;
typedef	TypeYUV<double> DoubleYUV;
typedef	TypeYIQ<double>	DoubleYIQ;
typedef TypeHSV<double> DoubleHSV;

class CCompositeViewerDoc : public CDocument
{
private:
	DoubleRGB	m_RGB;
	bool			m_details;
	bool			m_clip;
protected: // create from serialization only
	CCompositeViewerDoc();
	DECLARE_DYNCREATE(CCompositeViewerDoc)

// Attributes
public:
	DoubleRGB	GetRGB() const {return m_RGB;}
	bool			GetShowDetails() const {return m_details;}
	bool			GetClip() const {return m_clip;}

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCompositeViewerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCompositeViewerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCompositeViewerDoc)
	afx_msg void OnSetcolours();
	afx_msg void OnViewShowdetails();
	afx_msg void OnUpdateViewShowdetails(CCmdUI* pCmdUI);
	afx_msg void OnViewClip();
	afx_msg void OnUpdateViewClip(CCmdUI* pCmdUI);
	afx_msg void OnColoursRed();
	afx_msg void OnColoursGreen();
	afx_msg void OnColoursBlue();
	afx_msg void OnColoursCyan();
	afx_msg void OnColoursMagenta();
	afx_msg void OnColoursYellow();
	afx_msg void OnColoursWhite();
	afx_msg void OnColoursBlack();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMPOSITEVIEWERDOC_H__06ADA4EE_F991_11D4_BA86_000000000000__INCLUDED_)
